package juliac.generated;

import java.util.Collection;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import java.util.HashSet;
import org.ow2.frascati.tinfi.control.property.IllegalPromoterException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import java.util.List;
import java.util.Map;
import org.objectweb.fractal.api.control.NameController;
import org.ow2.frascati.tinfi.control.content.SCAContentController;
import org.ow2.frascati.tinfi.control.property.SCAPropertyController;
import java.util.Set;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin
 * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin
 * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin
 */
public class SCACompositePropertyControllerImpl implements Controller , Generated , SCAPropertyController {
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#values
     */
    private Map<java.lang.String, java.lang.Object>  values = new HashMap<java.lang.String, java.lang.Object> ();
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableSCACC = ((SCAContentController)(ic.interfaces.get(SCAContentController.NAME)));
        initFcController$1(ic);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#types
     */
    private Map<java.lang.String, java.lang.Class<?>>  types = new HashMap<java.lang.String, java.lang.Class<?>> ();
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#promoters
     */
    private Map<java.lang.String, org.ow2.frascati.tinfi.control.property.SCAPropertyController>  promoters = new HashMap<java.lang.String, org.ow2.frascati.tinfi.control.property.SCAPropertyController> ();
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#weaveableOptNC
     */
    public NameController weaveableOptNC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#setType(java.lang.String,java.lang.Class)
     */
    public void setType(String name, Class<?>  type) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            types.put(name ,type);
        } else {
            promoter.setType(name ,type);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin#weaveableSCACC
     */
    @SuppressWarnings(value = "unused")
    private SCAContentController weaveableSCACC;
    
    /** 
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptNC = ((NameController)(ic.getOptionalInterface("name-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#setValue(java.lang.String,java.lang.Object)
     */
    public void setValue(String name, Object value) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            values.put(name ,value);
        } else {
            promoter.setValue(name ,value);
        }
    }
    
    private void initFcController$2(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#getType(java.lang.String)
     */
    public Class<?>  getType(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            return types.get(name);
        } else {
            return promoter.getType(name);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#getValue(java.lang.String)
     */
    public Object getValue(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            return values.get(name);
        } else {
            return promoter.getValue(name);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#containsPropertyName(java.lang.String)
     */
    public boolean containsPropertyName(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            return values.containsKey(name);
        } else {
            return promoter.containsPropertyName(name);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#getPropertyNames()
     */
    public String[] getPropertyNames() {
        Set<java.lang.String>  keys = values.keySet();
        String[] names = keys.toArray(new String[keys.size()]);
        return names;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#containsDeclaredPropertyName(java.lang.String)
     */
    public boolean containsDeclaredPropertyName(String name) {
        Collection<org.ow2.frascati.tinfi.control.property.SCAPropertyController>  scapcs = promoters.values();
        for (SCAPropertyController scapc : scapcs) {
            if (scapc.containsDeclaredPropertyName(name)) {
                return true;
            } 
        }
        return false;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#getDeclaredPropertyNames()
     */
    public String[] getDeclaredPropertyNames() {
        Set<java.lang.String>  propnames = new HashSet<java.lang.String> ();
        Collection<org.ow2.frascati.tinfi.control.property.SCAPropertyController>  scapcs = promoters.values();
        for (SCAPropertyController scapc : scapcs) {
            String[] s = scapc.getDeclaredPropertyNames();
            propnames.addAll(java.util.Arrays.asList(s));
        }
        String[] names = propnames.toArray(new String[propnames.size()]);
        return names;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#getDeclaredPropertyType(java.lang.String)
     */
    public Class<?>  getDeclaredPropertyType(String name) {
        Collection<org.ow2.frascati.tinfi.control.property.SCAPropertyController>  scapcs = promoters.values();
        for (SCAPropertyController scapc : scapcs) {
            if (scapc.containsDeclaredPropertyName(name)) {
                Class<?>  type = scapc.getDeclaredPropertyType(name);
                return type;
            } 
        }
        return null;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#setPromoter(java.lang.String,org.ow2.frascati.tinfi.control.property.SCAPropertyController)
     */
    public void setPromoter(String name, SCAPropertyController promoter) throws IllegalPromoterException {
        promoters.put(name ,promoter);
        if (promoter != null) {
            SCAPropertyController peer = promoter.getPromoter(name);
            if (peer == (this)) {
                String compname = weaveableOptNC.getFcName();
                throw new IllegalPromoterException(compname);
            } 
        } 
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin#getPromoter(java.lang.String)
     */
    public SCAPropertyController getPromoter(String name) {
        return promoters.get(name);
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCACompositePropertyControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin org.objectweb.fractal.julia.control.name.UseNameControllerMixin org.ow2.frascati.tinfi.control.property.SCACompositePropertyControllerMixin)";
    }
    
}

